/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  // entry function
  window.addEventListener("load", function(evt) {
    var tabs = document.querySelectorAll(".tab");
    var tabpages = document.querySelectorAll(".tabpage");
    var tabs_container = document.querySelector("#tabs");
    var current = tabs_container.getAttribute("data-current");

    for (var i=0, l=tabs.length; i<l; i++) {
      if (current == i) {
        tabs[i].setAttribute("class", "tabActiveHeader");
        tabpages[i].style.display = "block";
      }
      tabs[i].addEventListener("click", displayPage);
    }

    /**
     *
     */
    function displayPage() {
      tabs[current].setAttribute("class", "tab");
      tabpages[current].style.display = "none";
      current = this.id.split("_")[1];

      tabs[current].setAttribute("class", "tabActiveHeader");
      tabpages[current].style.display = "block";
    }

    // 🔘○◯

    var buttonsPanel = new paramEditor.Panel("buttons");
    document.querySelector("#tabpage_buttons_0 .full_panel").appendChild(buttonsPanel.container);

    var spacesPanelListEdit = new paramEditor.PanelListEdit("Space", false);
    document.querySelector("#tabpage_spaces_1 .left_panel").appendChild(spacesPanelListEdit.container);
    var spacesPanel = new paramEditor.Panel("spaces");
    document.querySelector("#tabpage_spaces_1 .right_panel").appendChild(spacesPanel.container);
    
    var controlsPanelListEdit = new paramEditor.PanelListEdit("Controls", false);
    document.querySelector("#tabpage_controls_2 .left_panel").appendChild(controlsPanelListEdit.container);
    var controlsPanel = new paramEditor.Panel("controls");
    document.querySelector("#tabpage_controls_2 .right_panel").appendChild(controlsPanel.container);
    
    var definitionsPanelListEdit = new paramEditor.PanelListEdit("Definitions", false);
    document.querySelector("#tabpage_definitions_3 .left_panel").appendChild(definitionsPanelListEdit.container);
    var definitionsPanel = new paramEditor.Panel("definitions");
    document.querySelector("#tabpage_definitions_3 .right_panel").appendChild(definitionsPanel.container);
    
    var programsPanelListEdit = new paramEditor.PanelListEdit("Programs", false);
    document.querySelector("#tabpage_programs_4 .left_panel").appendChild(programsPanelListEdit.container);
    var programsPanel = new paramEditor.Panel("programs");
    document.querySelector("#tabpage_programs_4 .right_panel").appendChild(programsPanel.container);
    
    var graphicsPanelListEdit = new paramEditor.PanelListEdit("Graphics", false);
    document.querySelector("#tabpage_graphics_5 .left_panel").appendChild(graphicsPanelListEdit.container);
    var graphicsPanel = new paramEditor.Panel("graphics");
    document.querySelector("#tabpage_graphics_5 .right_panel").appendChild(graphicsPanel.container);
    
    var graphics3DPanelListEdit = new paramEditor.PanelListEdit("Graphics 3D", false);
    document.querySelector("#tabpage_graphics3D_6 .left_panel").appendChild(graphics3DPanelListEdit.container);
    var graphics3DPanel = new paramEditor.Panel("graphics3D");
    document.querySelector("#tabpage_graphics3D_6 .right_panel").appendChild(graphics3DPanel.container);
    
    var animationPanel = new paramEditor.Panel("animation");
    document.querySelector("#tabpage_animation_7 .full_panel").appendChild(animationPanel.container);

  });

  paramEditor.setParams = function(param) {
    console.log(param);
  }

  return paramEditor;
})(paramEditor || {});