/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.PanelListEdit = function(name, withSpaceList) {
    this.components = {};
    this.container = document.createElement("div");
    this.container.setAttribute("class", "panelListEdit");

    var rnd = parseInt(Math.random()*1000);
    
    this.menu = document.createElement("select");
    this.menu.setAttribute("id", name+"_menu_"+rnd);
    this.makeOptions([]);

    this.btnName = document.createElement("button");
    this.btnName.innerHTML = name;

    var btnContainer = document.createElement("div");
    btnContainer.setAttribute("class", "btnContainer");

    this.addBtn = document.createElement("button");
    this.addBtn.innerHTML = "+";
    this.cloneBtn = document.createElement("button");
    this.cloneBtn.innerHTML = "*";
    this.removeBtn = document.createElement("button");
    this.removeBtn.innerHTML = "-";

    this.listPanel = document.createElement("div");
    this.listPanel.setAttribute("class", "listPanel");

    this.container.appendChild(this.menu);
    this.container.appendChild(this.btnName);
    this.container.appendChild(btnContainer);
    this.container.appendChild(this.listPanel);
    btnContainer.appendChild(this.addBtn);
    btnContainer.appendChild(this.cloneBtn);
    btnContainer.appendChild(this.removeBtn);

  }

  /**
   *
   */
  paramEditor.PanelListEdit.prototype.makeOptions = function(options) {
    // remove all previous children
    while (this.menu.firstChild) {
      this.menu.removeChilde(this.menu.firstChild);
    }

    // add the new children
    var tmpOption;
    for (var i=0, l=options.length; i<l; i++) {
      tmpOption = document.createElement("option");
      tmpOption.setAttribute("value", options[i]);
      tmpOption.innerHTML = options[i];
      this.menu.appendChild(tmpOption);
    }
  }

  /**
   *
   */
  paramEditor.PanelListEdit.prototype.setButtonName = function(name) {
    this.btn.innerHTML = name;
  }

  return paramEditor;
})(paramEditor || {});